: D-  ( d1|ud1 d2|ud2 -- d3|ud3 )
   DNEGATE D+ 
;

: D>S ( d -- n ) DROP ;

: UNLOOP
   R> 12 NRDROP
   >R
;

: LEAVE
   12 NRDROP
;

: 2RDROP
  R> RDROP RDROP >R
;

: -ROT ROT ROT ;

: DUP>R
    DUP R> 2>R  \ DUP >R
;

: /MOD ( n1 n2 -- n3 n4 ) \ 94
   2DUP / >R MOD R>
;

: M* ( n1 n2 -- d )
   DUP  0< >R ABS SWAP
   DUP 0< >R ABS UM*
   2R> XOR IF DNEGATE THEN
;

( from 1001 )
: SM/REM ( d1 n1 -- n2 n3 )
   DUP 0< IF -1 >R ABS ELSE 0 >R THEN -ROT
   DUP 0< IF -1 >R DNEGATE ELSE 0 >R THEN  ROT UM/MOD
   R> R@ XOR IF NEGATE SWAP NEGATE SWAP THEN
   SWAP R> IF NEGATE THEN SWAP 
;

: */MOD >R M* R> SM/REM ;

: */    */MOD NIP ;

: ERASE ( addr u )
    0 FILL
;

: CELL/ 2/ 2/ 
\ is equal to 2/ 2/
;

: DEPTH ( -- u )
  SP@ S0 @ - NEGATE CELL/
;

: HEX
   16 BASE !
;
: DECIMAL
   10 BASE !
;

: S>D ( n -- d )
   DUP 0<
;

: D=  ( xd1 xd2 -- flag ) D- OR 0= ;

: D< ( xd1 xd2 -- flag )
   ROT 2DUP <>
   IF  SWAP < NIP NIP
   ELSE 2DROP <
   THEN
;

: D0< ( d -- flag ) NIP 0< ;

: D0= ( xd -- flag ) OR 0= ;

: M+  ( d1|ud1 n -- d2|ud2 ) S>D D+ ;

: D2* ( xd1 -- xd2 ) 2DUP D+ ;

: D2/ ( xd1 -- xd2 )
   DUP 1 AND >R
   2/ SWAP 1 RSHIFT
   R> 31 LSHIFT OR SWAP
;

: DABS ( d -- ud ) \ 94 DOUBLE
\ ud   d.
  DUP 0< IF DNEGATE THEN
;

: DMAX ( d1 d2 -- d3 )
  2OVER 2OVER
  D< IF 2SWAP THEN
  2DROP
;

: DMIN ( d1 d2 -- d3 )
  2OVER 2OVER
  D< INVERT IF 2SWAP THEN
  2DROP
;

: 2! ( d a-addr -- ) 
  TUCK ! CELL+ !
;

: 2@ ( a-addr -- d )
  DUP CELL+ @
  SWAP @
;

: ALIGNED ( addr -- a-addr )                                                    ( CORE)
   DUP 1 AND + ;

: ALIGN
   DP @ ALIGNED DP !
;

: SaveInts
   0x08 >rel @ _adrsh !
   0x0C >rel @ _bush  !
   0x14 >rel @ _divzh !

;
: RestoreInts
   _adrsh @ 0x08 >rel !
   _bush  @ 0x0C >rel !
   _divzh @ 0x14 >rel !
;

: HALT ( n -- )
\ release all of resources and quit from an application with code n
   OSVER @ 0x3000000 < 0=
   IF
     TLS @ FREE DROP THEN
   SOURCE-ID ?DUP IF >abs MemPtrUnlock DROP THEN
   FrmCloseAllForms
\   ?APP @ 0= IF RestoreInts THEN
   (BYE)
;

: BYE
   0 HALT
;

: ON  ( addr -- )
\ store TRUE into variable addr
  TRUE SWAP ! 
;

: OFF 0! 
\ store FALSE into variable addr.
\ is equal to 0!
;

: WITHIN ( test low high -- flag)
  OVER -  >R - R>  U< 
;

: SEARCH ( c-addr1 u1 c-addr2 u2 -- c-addr3 u3 flag ) \ 94 STRING
    2>R 2DUP
    BEGIN
      DUP 1+ R@ > \   
    WHILE
      OVER 2R@ TUCK COMPARE 0=
      IF 2RDROP 2SWAP 2DROP TRUE EXIT THEN
      1- SWAP 1+ SWAP
    REPEAT 2RDROP 2DROP 0
;

\ : MOVE ( addr1 addr2 u -- ) \ 94
\  >R 2DUP SWAP R@ + U< \       
\  IF 2DUP U<           \   
\     IF R> CMOVE> ELSE R> CMOVE THEN
\  ELSE R> CMOVE THEN
\ ;

: RVARW ( -- abs-addr ) ( r: -- 0 )
  R>
  0 W>R RP@ >abs
  SWAP >R
;
