
CREATE C-SMUDGE 12 C, 0 C,

: SMUDGE ( -- )
\ disable current definitions so it will not be found until next SMUDGE.
\ is applied for recursion and so on.
  LATEST
  IF
    C-SMUDGE C@
    LATEST L>NAME 1+ DUP N> C@
    C-SMUDGE C! N-C!
  THEN
;

: HIDE
  12 C-SMUDGE C! SMUDGE
;

: IMMEDIATE ( -- )
  LATEST CELL+
  DUP N> C@ 0x80 OR SWAP N-C!
;

: :NONAME ( -- xt )
    THERE
    [ _ENTER ] LITERAL
    COMPILE,
    ]
    LATEST L>NAME 1+ N> C@
    C-SMUDGE C!
;

: ;  ( -- )
  POSTPONE EXIT
  POSTPONE [
  SMUDGE
; IMMEDIATE

: SHEADER ( addr u -- )
\ append word header with name of (addr u) to
\ the current vocabulary
  DUP 31 > -19 ?THROW
  2DUP CURRENT @ SEARCH-WORDLIST
    IF DROP WARNING @ IF
         2DUP TYPE S"  isn't unique" TYPE CR 
         THEN
    THEN
  CURRENT @ +SWORD THERE LAST-CFA !
;

: HEADER ( "name" -- )
\ Is equal to NextWord SHEADER
  NextWord SHEADER
;

: CREATED ( addr u -- )
\ Create a definition for name with the execution semantics defined below. 
\ name Execution: ( -- a-addr )
\ a-addr is the address of name's data field. The execution semantics of name may be extended by using DOES>. 
  SHEADER
  [ _CREATE_DOES ] LITERAL
  COMPILE,
  HERE T-W,
;

: CREATE ( "name" -- )
\ Is equal to: NextWord CREATED
  NextWord CREATED
;

: VARIABLE ( "name" -- )
  CREATE
  0 ,
;

: CONSTANT ( "name" -- )
  HEADER
  DUP ?SHORT IF
    [ _WCONST_DOES ] LITERAL
    COMPILE,
    T-W,
  ELSE
    [ _CONST_DOES ] LITERAL
    COMPILE,
    T-,
  THEN
;

: :  ( "name" -- )
  HEADER
  :NONAME DROP
  HIDE
;

: (DOES) 
  LAST-CFA @ THERE CELL- = IF \  뫮 DOES>
    [ _DOES  ] LITERAL
    THERE CELL- T-W!
    R> T-W,
  ELSE
    R> THERE 2 - T-W!
  THEN
;

: DOES> ( -- addr )
  POSTPONE (DOES)
; IMMEDIATE
  
  
: VALUE ( u -- )
  HEADER
  [ _VALUE_DOES ] LITERAL
  COMPILE, HERE T-W,
  ,
;

: --  ( n1 n1 "name" )
  HEADER
  [ _FIELD_DOES ] LITERAL
  COMPILE, OVER T-W, +
;

: enum ( n -- )  
  CREATE ,
  (DOES) ( -- n )
  DUP @ CONSTANT 1 SWAP +! 
;

: TO ( "name" )
  ' DUP T> W@
  [ _USER_VALUE_DOES ] LITERAL
  = IF ['] pUTO
    ELSE ['] pTO
    THEN
  STATE @
  IF
    COMPILE,
    >BODY COMPILE,
  ELSE
    ['] pUTO = 
    IF 
      >BODY TLS @ +
    ELSE >BODY
    THEN !
  THEN
; IMMEDIATE

: 2CONSTANT  ( "name" )
  CREATE , , (DOES) 2@
;

: 2VARIABLE ( "name" )
  VARIABLE 
  0 ,
;

: TASK: ( dsSize rsSize -- )
   CREATE 0 , W, W, USER-OFFS @ W,
;

: USER-ALLOT ( n -- )
   USER-OFFS +!
;

: USER-CREATE ( "name" )
   HEADER
   [ _USER_DOES ] LITERAL
   COMPILE,
   USER-OFFS @ T-W,
;

: USER  ( "name" )
   USER-CREATE
   CELL USER-ALLOT
;
: USER-VALUE ( "name" )
   HEADER
   [ _USER_VALUE_DOES ] LITERAL
   COMPILE,
   USER-OFFS @ T-W,
   CELL USER-ALLOT
;

: VECT ( -- )
  HEADER
  [ _VECT_DOES ] LITERAL
  COMPILE, HERE T-W,
  ['] NOOP ,
;

: CALLBACK-1: ( xt -- )
   HEADER
   [ _CALLBACK ] LITERAL
   COMPILE, HERE T-W,

   0x203C W, THERE ,   \ move.l  #xxx, d0
   0x206D W, 0x8012 W, \ move.l  vCBPROC(a5), a0
   0x4ED0 W,           \ jmp     (a0)
   COMPILE,
   POSTPONE ENDCB
;

: CALLBACK ( xt -- xt1 )
   THERE >R
   [ _CALLBACK ] LITERAL
   COMPILE, HERE T-W,

   0x203C W, THERE ,   \ move.l  #xxx, d0
   0x206D W, 0x8012 W, \ move.l  vCBPROC(a5), a0
   0x4ED0 W,           \ jmp     (a0)
   COMPILE,
   POSTPONE ENDCB
   R>
;

: CALLBACK0:
  CALLBACK
  : POSTPONE LITERAL EXECUTE POSTPONE ;
;

: CALLBACK:
  CALLBACK CREATE ,
  (DOES)
    @ EXECUTE
;